# -*- coding:Utf-8 -*-
import es, re, psyco, random
psyco.full()


regex = re.compile('//.*|(\r)+|(\n)+|(")+|')

class DmVotemap(object):
    """ Weapon Management """

    def __init__(self):
        self.mapfile = es.getString("eventscripts_gamedir") + "/cfg/dm_python/maplist.txt"
        self.maplist = []
        self.lastmap = []

    def read(self):
        try:
            openfile = open(self.mapfile, "rb")
            for mapname in map(lambda line: regex.sub("", line).strip(), openfile.readlines()):
                if mapname:
                    if es.exists("map", mapname):
                        if not mapname in self.maplist: self.maplist.append(mapname)
                    else: es.dbgmsg(0, 'dm_python: cannot add map "%s", it does not exists' % mapname)
            openfile.close()
        except IOError:
            es.dbgmsg(0, "dm_python: cannot read file cfg/dm_python/maplist.txt" % filepath)
            return []

    def new(self):
        self.lastmap.insert(0, es.getString("eventscripts_currentmap"))
        self.lastmap = self.lastmap[:es.getInt("dp_vote_lastmaps")]

    def get(self):
        maplist = self.maplist[:]
        for mapname in self.lastmap:
            if mapname in maplist: maplist.remove(mapname)
        mapcount = len(maplist)
        mapmax = es.getInt("dp_vote_maxmap")
        if not mapmax: return maplist
        return random.sample(maplist, mapmax if mapmax <= mapcount else mapcount)
